CREATE FUNCTION [dbo].[udfProperCase](@OriginalText AS VARCHAR(255)) RETURNS VARCHAR(255) AS BEGIN
--DECLARE @OriginalText AS VARCHAR(255)
--SET @OriginalText = 'City of industry'
--'david mcafee'
--'shannon o' +char(39) + 'niel'
--'eee movers'
--'tom' + char(39) + 's diner'
--'McAfee'
--'mcdonalds'
--'mclaughlins'
--'oscar DE la hoya'
--'A.B.C. Industries'
--'B+B Mfg'
--'sonia diMartini'


DECLARE @ttbl AS TABLE (PK INT IDENTITY(1,1), String VARCHAR(255), StringType TinyInt, StringLen TinyINT, WordStartPos TinyInt)
DECLARE @TempText AS VARCHAR(255), @CurrentCharacter AS CHAR(1), @SomeString AS VARCHAR(255), @intCounter AS TINYINT = 1
	--Type 0 = Word
	--Type 1 = Delimiter
	--Type 2 = Corrected/Excluded
--DECLARE @OriginalText AS VARCHAR(255) =--'sharon o''conner'-- --'david mcafee'

WHILE  @IntCounter <= LEN(@OriginalText) 
	BEGIN
		SELECT @CurrentCharacter = SUBSTRING(@OriginalText, @intCounter , 1)
		IF @CurrentCharacter IN (' ', '-', '/', '.', '+', '&', CHAR(13), CHAR(10),CHAR(39)) 
			BEGIN
				IF @TempText IS NOT Null INSERT INTO @ttbl(String, StringType, StringLen, WordStartPos) VALUES (@TempText, 0, LEN(@TempText),@IntCounter-LEN(@TempText));
				INSERT INTO @ttbl(String, StringType, StringLen, WordStartPos) VALUES (@CurrentCharacter, 1, 1, @IntCounter);
				SET @TempText=Null;
				--SELECT @intCounter AS IntCounter, @CurrentCharacter
			END
		ELSE SET @TempText = ISNULL(@TempText,'') + @CurrentCharacter
			
		SET @IntCounter = @intCounter+1
	END  
INSERT INTO @ttbl(String, StringType, StringLen, WordStartPos) VALUES (@TempText, 0, LEN(@TempText), @IntCounter-LEN(@TempText));

--SELECT * FROM @ttbl

--First overwrite any exclusions and Change them from 0 to -1
UPDATE @ttbl SET String = B.ExceptionText, StringType=2  --SELECT * 
FROM @ttbl A
INNER JOIN DavidWorkspace..tblProperCaseExclusions B WITH (NOLOCK) ON UPPER(A.String) = UPPER(B.ExceptionText)
WHERE StringType = 0

UPDATE @ttbl 
SET String = 
	CASE
		WHEN (StringLen = 2 AND (UPPER(LEFT(String,1))=UPPER(RIGHT(String,1)))) --Loop through 2/3 char words (This section can be commented out if Identical 2/3 letter words should not be made upper case (AAA, II, CE)
				OR 
				(StringLen = 3 AND (UPPER(LEFT(String,1))=UPPER(RIGHT(String,1))) 
				            AND (UPPER(LEFT(String,1))=UPPER(SUBSTRING(String,2,1)))) THEN UPPER(String)  --SELECT * 
		WHEN StringLen>3 AND LEFT(String,2) IN ('MC',('O'+CHAR(39))) THEN UPPER(LEFT(String,1)) + SUBSTRING(String,2,1) + UPPER(SUBSTRING(String,3,1)) + LOWER(RIGHT(String,LEN(String)-3))--Mc or O'
		ELSE UPPER(LEFT(String,1)) + LOWER(RIGHT(String, LEN(String)-1))
	END 
FROM @ttbl 
WHERE StringType = 0 --AND StringLen IN (2,3)

--Reassemble string
SELECT @TempText = '', @IntCounter=1

WHILE @IntCounter <= (SELECT Max(PK) FROM  @ttbl) BEGIN
	SELECT @SomeString = String FROM @ttbl WHERE PK =@intCounter;
	SET @TempText += @SomeString;
	SET @IntCounter = @intCounter+1
END

--SELECT @TempText
RETURN --SELECT 
 REPLACE(@TempText, 'De La ','de la ');
 END
