ALTER FUNCTION udfProperCase(@OriginalText AS VARCHAR(255)) RETURNS VARCHAR(255) 
AS
BEGIN
--DECLARE @OriginalText AS VARCHAR(255)
--SET @OriginalText = 
--'david mcafee'
--'shannon o' +char(39) + 'niel'
--'eee movers'
--'tom' + char(39) + 's diner'
--'McAfee'
--'mcdonalds'
--'mclaughlins'
--'oscar DE la hoya'
--'A.B.C. Industries'
--'B+B Mfg'
--'sonia diMartini'
DECLARE @intCounter AS INT
DECLARE @OneChar AS CHAR(1)
DECLARE @StartingNumber AS INT
SET @intCounter = 0
SET @StartingNumber = 1


IF RIGHT(LEFT(@OriginalText, 4), 1) = ' ' 	--***********************  3 Letter Check *****************************************
	--Check for 3 character words at the start of string
	--The line below checks for all 3 characters to be equal, and capitalize if so "AAA" or "EEE Movers"
    IF (LEFT(@OriginalText, 1) = SUBSTRING(@OriginalText, 2, 1) AND LEFT(@OriginalText, 1) = SUBSTRING(@OriginalText, 3, 1)) BEGIN
    	--Capitalize the 3 char's
        SET @OriginalText = UPPER(LEFT(@OriginalText, 3)) + LOWER(SUBSTRING(@OriginalText, 4, 255))
        SET @StartingNumber = 4
		END
    ELSE BEGIN 
        --Only capitalize the first of the 3 char's
        SET @OriginalText = UPPER(LEFT(@OriginalText, 1)) + LOWER(SUBSTRING(@OriginalText, 2, 255))
        SET @StartingNumber = 2
    END
--******************** End 3 letter check ***************************************************************************

ELSE IF RIGHT(LEFT(@OriginalText, 3), 1) = ' ' --Check for 2 character words as the start of the string*****************
    IF LEFT(@OriginalText, 1) = SUBSTRING(@OriginalText, 2, 1) 
		BEGIN
        --Capitalize the 2 char's
        SET @OriginalText = UPPER(LEFT(@OriginalText, 2)) + LOWER(SUBSTRING(@OriginalText, 3, 255))
        SET @StartingNumber = 3
		END
    ELSE
		BEGIN
        --Only capitalize the first of the 2 char's
        SET @OriginalText = UPPER(LEFT(@OriginalText, 1)) + LOWER(SUBSTRING(@OriginalText, 2, 255))
        SET @StartingNumber = 2
	END
-- **************** End the 2 character word Check *****************************************************************************
			
ELSE --Convert first character to capital then the rest to lowercase
BEGIN
    SET @OriginalText = UPPER(LEFT(@OriginalText, 1)) + LOWER(SUBSTRING(@OriginalText, 2, 255))
	SET @StartingNumber = 2
END	



--  'Look at each character, starting at the second character. 	

WHILE @intCounter < LEN(@OriginalText)
BEGIN
	SET @intCounter = @intCounter +1
	SET @OneChar = SUBSTRING(@OriginalText, @intCounter, 1)
	IF @OneChar IN('-', '/', '.', '+') SET @OriginalText = LEFT(@OriginalText, @intCounter) + UPPER(SUBSTRING(@OriginalText, @intCounter + 1, 1)) + SUBSTRING(@OriginalText, @intCounter + 2, 255)
	    --Convert the character after dash/hyphen/slash/period/ampersand to uppercase such as "A.B.C. Industries", B+B Mfg
	ELSE IF @OneChar = CHAR(39) -- ' Check the character two places after the apostrophe.
		IF (SUBSTRING(@OriginalText, @intCounter + 2, 1) <> ' ') AND (@intCounter + 2 <= LEN(@OriginalText)) SET @OriginalText = LEFT(@OriginalText, @intCounter) + UPPER(SUBSTRING(@OriginalText, @intCounter + 1, 1)) + SUBSTRING(@OriginalText, @intCounter + 2, 255)
	ELSE IF @OneChar = 'c' --Take care of the McAfee's, McDonalds + McLaughlins and such
		SET @onechar = @onechar
		IF (SUBSTRING(@OriginalText, @intCounter - 1, 2) = 'Mc') 
		BEGIN
			SET @onechar = @onechar
			IF ((@intCounter - 2) < 1) 
				BEGIN
				SET @OriginalText ='Mc' + UPPER(SUBSTRING(@OriginalText, @intCounter + 1, 1)) + SUBSTRING(@OriginalText, @intCounter + 2,LEN(@OriginalText)-3)--255)
				END
			ELSE IF (SUBSTRING(@OriginalText, @intCounter - 2, 1) = ' ') 
				SET @OriginalText = LEFT(@OriginalText, @intCounter) + UPPER(SUBSTRING(@OriginalText, @intCounter + 1, 1)) + SUBSTRING(@OriginalText, @intCounter + 2, 255)		
		END
	ELSE IF @OneChar = ' '	--First, check for any exceptions. This could be handled with values in a table, but since this is ported from my FE VBA app, I'm leaving it this way
	BEGIN
		IF SUBSTRING(@OriginalText, @intCounter + 1, 3) = 'de '	BEGIN --'Add any other exceptions here Example: Oscar de La Hoya", don't capitalize the "de"
	       	SET @OriginalText = LEFT(@OriginalText, @intCounter) + 'de ' + SUBSTRING(@OriginalText, @intCounter + 4, 255)
	        SET @intCounter = @intCounter + 3
			END
	    ELSE SET @OriginalText = LEFT(@OriginalText, @intCounter) + UPPER(SUBSTRING(@OriginalText, @intCounter + 1, 1)) + SUBSTRING(@OriginalText, @intCounter + 2, 255)
	
        IF SUBSTRING(@OriginalText, @intCounter + 1, 9) = 'diMartini' SET @OriginalText = LEFT(@OriginalText, @intCounter) + 'diMartini' + SUBSTRING(@OriginalText, @intCounter + 10, 255)
		    
		--*********************** Check for 3 character word *******************
        IF SUBSTRING(@OriginalText, @intCounter + 4, 1) = ' ' OR (LEN(@OriginalText) - @intCounter = 3)
			IF (SUBSTRING(@OriginalText, @intCounter + 1, 1) = SUBSTRING(@OriginalText, @intCounter + 2, 1) AND SUBSTRING(@OriginalText, @intCounter + 1, 1) = SUBSTRING(@OriginalText, @intCounter + 3, 1))
				BEGIN
				--Capitalize the 3 char's
				SET @OriginalText = LEFT(@OriginalText, @intCounter) + UPPER(SUBSTRING(@OriginalText, @intCounter + 1, 3)) + SUBSTRING(@OriginalText, @intCounter + 4, 255)
				SET @intCounter = @intCounter + 3
				END
			ELSE
		    	SET @OriginalText = LEFT(@OriginalText, @intCounter) + UPPER(SUBSTRING(@OriginalText, @intCounter + 1, 1)) + SUBSTRING(@OriginalText, @intCounter + 2, 255)
		-- ********************** check for 2 char words *******************
        ELSE IF SUBSTRING(@OriginalText, @intCounter + 3, 1) = ' ' OR (LEN(@OriginalText) - @intCounter = 2)
	    	IF (SUBSTRING(@OriginalText, @intCounter + 1, 1) = SUBSTRING(@OriginalText, @intCounter + 2, 1)) 
				BEGIN
				-- Capitalize the 2 char's
		        SET @OriginalText = LEFT(@OriginalText, @intCounter) + UPPER(SUBSTRING(@OriginalText, @intCounter + 1, 2)) + LOWER(SUBSTRING(@OriginalText, @intCounter + 3, 255))
		        SET @intCounter = @intCounter + 2
				END
			ELSE
				BEGIN
				--Only capitalize the first of the 2 char's
	            SET @OriginalText = LEFT(@OriginalText, @intCounter) + UPPER(SUBSTRING(@OriginalText, @intCounter + 1, 1)) + SUBSTRING(@OriginalText, @intCounter + 2, 255)
	            SET @intCounter = @intCounter + 1
	        END
		-- ******************** END 2 LETTER CHECK
	END
END --WHILE

RETURN @OriginalText
END